diff --git a/examples/systemd/hive-web.service b/examples/systemd/hive-web.service
new file mode 100644
index 000000000..e4585d3fa
--- /dev/null
+++ b/examples/systemd/hive-web.service
@@ -0,0 +1,53 @@
+# Sample systemd-user unit for `hive web` (Linux) — the managed web
+# service lifecycle (`hive web install` / `hive web start`).
+#
+# The web UI is a SEPARATE service from `hive-daemon` by design: local
+# mode runs the Rails app and the daemon as distinct units so each can be
+# restarted independently. Daemon + web are never merged into one unit.
+#
+# The unit runs `hive web run` in the FOREGROUND — systemd is the
+# supervisor, so there is no in-process daemonization (compare the
+# container supervisor, which spawns `hive web --bind 0.0.0.0` directly).
+#
+# BEFORE INSTALLING: edit ExecStart= to match where YOUR `hive` binary
+# lives. `which hive` shows it. Common paths:
+#
+#   %h/.local/bin/hive                           ← README install (option-A
+#                                                  symlink: ln -s ~/Dev/hive/bin/hive ~/.local/bin/hive)
+#   %h/Dev/hive/bin/hive                         ← README install (option-B,
+#                                                  direct from clone, no symlink)
+#   /usr/local/bin/hive                          ← system gem install
+#   %h/.local/share/mise/shims/hive              ← mise / rbenv / asdf / chruby shim
+#
+# `hive web install` rewrites ExecStart=, Environment=PATH= to match the
+# resolved binary + Ruby manager detected on the host (exactly like
+# `hive daemon install`). The web bind/port are read from the same
+# ~/.config/hive/config.yml the CLI uses, so the unit needs no baked
+# --bind/--port.
+#
+# This unit locally binds 127.0.0.1:4567 by default (web.bind/web.port).
+# Binding a non-loopback interface without web.github.owner or an
+# explicit --allow-non-loopback/--unsafe flag is refused by the CLI.
+
+[Unit]
+Description=Hive local web UI (rails server, foreground)
+After=default.target
+# Cap the auto-restart loop so a misconfigured ExecStart= (binary not on
+# PATH, missing bundle) stops cleanly with `failed` instead of respawning
+# forever.
+StartLimitBurst=3
+StartLimitIntervalSec=300
+
+[Service]
+Type=simple
+Environment=HIVE_BIN=%h/.local/bin/hive
+Environment=PATH=%h/.local/bin:/usr/local/bin:/usr/bin:/bin
+ExecStart=%h/.local/bin/hive web run
+Restart=on-failure
+RestartSec=10s
+# No WebStorage drain like the daemon's child drain; rails handles SIGTERM
+# and exits promptly. Keep a modest stop timeout.
+TimeoutStopSec=30
+
+[Install]
+WantedBy=default.target
diff --git a/lib/hive.rb b/lib/hive.rb
index b22bfe0e3..03443dd5e 100644
--- a/lib/hive.rb
+++ b/lib/hive.rb
@@ -30,6 +30,10 @@ module Hive
       "hive-daemon-enroll" => 1,
       "hive-daemon-reload" => 1,
       "hive-daemon-install" => 1,
+      # Explicit binary/version-drift repair (`hive daemon repair --json`):
+      # re-runs the daemon unit install --force so it points at the CLI's
+      # binary, reporting the reinstall outcome.
+      "hive-daemon-repair" => 1,
       # Read-only inspection of the daemon's dispatch-request queue
       # (`hive daemon queue [list|show|prune]`). See AN-1/2/3 and
       # `Hive::Commands::Daemon#queue_command`.
@@ -57,6 +61,26 @@ module Hive
       "hive-bot-stop" => 1,
       "hive-bot-reload" => 1,
       "hive-bot-install" => 1,
+      # Managed local web service lifecycle (`hive web install` / status).
+      # The web service is SEPARATE from the hive daemon: daemon + web are
+      # never merged into one unit, so each can be restarted independently.
+      "hive-web-install" => 1,
+      "hive-web-status" => 1,
+      # Managed local web service lifecycle (`hive web start` / `hive web
+      # stop`). Mirrors the daemon/bot stop envelopes: ok reports whether the
+      # service manager accepted the request; unit_path is the managed unit.
+      "hive-web-start" => 1,
+      "hive-web-stop" => 1,
+      # Dependency verification for `hive setup` (U3): a row per probed dep
+      # (ruby/git/tmux/gh/claude/codex/node/npm/qmd/web bundle/sqlite) with a
+      # precise fix command for anything missing, plus any Hive-owned
+      # bootstraps attempted (qmd install, web bundle install).
+      "hive-dependency-check" => 1,
+      # One-shot full local setup orchestration (`hive setup --json`): the
+      # overall ok + per-step status arms (backends / dependencies / daemon /
+      # enroll / web / health), the dependency row set, and the health probe
+      # result at the configured web origin.
+      "hive-setup" => 1,
       # File-backed dispatch request the bot writes for the daemon to
       # consume. One JSON file per pending request under the state-home
       # `dispatch_requests/` directory. See
@@ -392,6 +416,7 @@ module Hive
   #   3   task is in :error marker state (a stage agent recorded an error)
   #   4   wrong stage (`hive run` on an inert 1-inbox folder, etc.)
   #   64  EX_USAGE — invalid argument: bad slug, malformed task path, …
+  #   65  EX_DATAERR — a required fix was surfaced (`hive setup` / `hive doctor`)
   #   70  EX_SOFTWARE — internal error: git failure, worktree failure, agent failure, stage runner error
   #   75  EX_TEMPFAIL — retryable: lock contention (`ConcurrentRunError`)
   #   78  EX_CONFIG — bad project / global config
@@ -405,6 +430,7 @@ module Hive
     TASK_IN_ERROR = 3
     WRONG_STAGE = 4
     USAGE = 64
+    FIX_REQUIRED = 65
     UNAVAILABLE = 69
     SOFTWARE = 70
     TEMPFAIL = 75
diff --git a/lib/hive/cli.rb b/lib/hive/cli.rb
index cd8090689..fc601ca68 100644
--- a/lib/hive/cli.rb
+++ b/lib/hive/cli.rb
@@ -44,6 +44,43 @@ module Hive
 
     FINDING_SEVERITY_ENUM = %w[high medium low nit].freeze
 
+    desc "setup", "One-shot full local setup: deps + web bundle + backends + daemon + web + health"
+    long_desc <<~DESC
+      Runs the full local (non-Docker) setup for the Hive web UI, in order:
+
+        1. Global backends — interactive selection on a TTY; on a non-TTY
+           (CI / agents / daemon) the registered defaults are persisted
+           without prompting. Pass --non-interactive to force that.
+        2. Dependencies — verifies ruby 3.4, git, tmux, gh, claude, codex,
+           node/npm/qmd, the web bundle, and sqlite; bootstraps Hive-owned
+           deps (qmd, web bundle). External agent CLIs (gh/claude/codex)
+           are probed but NEVER auto-installed or auto-authenticated — the
+           exact fix command is printed and the run reports fix_required.
+        3. Daemon service — ensures the daemon unit points at the SAME
+           hive binary/version as the CLI (never merged with web).
+        4. Enrollment — registers the current repo when run inside an
+           unregistered git repo (full `.hive-state` bootstrap stays the
+           explicit `hive init` step; never force-inits or prompts).
+        5. Web service — ensures the web unit (separate from the daemon).
+        6. Health — probes the configured web origin's /health?deep=1.
+
+      With --json, emits a hive-setup.v1 envelope with per-step status.
+      Never touches the Docker/hivebox path and never merges daemon+web.
+    DESC
+    option :non_interactive, type: :boolean, default: false,
+                             desc: "skip prompts even on a TTY (use default backends)"
+    option :bind, type: :string, desc: "override web.bind for the health probe"
+    option :port, type: :numeric, desc: "override web.port for the health probe"
+    def setup
+      require "hive/commands/setup"
+      exit Hive::Commands::Setup.new(
+        json: options[:json],
+        non_interactive: options[:non_interactive],
+        bind: options[:bind],
+        port: options[:port]
+      ).call
+    end
+
     desc "version", "Print hive version"
     def version
       puts Hive::VERSION
@@ -1037,14 +1074,17 @@ module Hive
       ).call
     end
 
-    desc "daemon SUBCOMMAND [PROJECT]", "Manage the hive daemon (start / stop / status / reload / tail / install / enable / disable / queue)"
+    desc "daemon SUBCOMMAND [PROJECT]", "Manage the hive daemon (start / stop / status / reload / tail / install / enable / disable / queue / repair)"
     long_desc <<~DESC
       Subcommands:
         start [--detach] [--dry-run]      Run the dispatcher loop. Without
                                           --detach, runs in the foreground.
         stop [--json]                     Send SIGTERM to the running daemon.
                                           --json emits hive-daemon-stop.v1.
-        status [--json]                   Show running / not-running.
+        status [--json]                   Show running / not-running. --json
+                                          reports the running daemon's binary +
+                                          version and whether it DRIFTED from
+                                          the CLI (U5).
         reload [--json]                   Send SIGHUP to reload config.
                                           --json emits hive-daemon-reload.v1.
         tail                              Stream daemon.log.
@@ -1058,6 +1098,14 @@ module Hive
                                           the running daemon so new
                                           Environment= lines take effect.
                                           --json emits hive-daemon-install.v1.
+        repair [--json]                   Explicit binary/version-drift repair:
+                                          re-runs install --force so the unit
+                                          points at the CURRENT CLI binary,
+                                          then restart. Drift is reported by
+                                          status but only fixed on this
+                                          explicit path (or via `hive setup` /
+                                          the web repair button). --json emits
+                                          hive-daemon-repair.v1.
         enable  PROJECT|--all [--json]    Set daemon.enabled: true in
                                           <project>/.hive-state/config.yml.
                                           --all = every registered project;
@@ -1332,18 +1380,46 @@ module Hive
       ).call
     end
 
-    desc "web", "Run the hivebox web UI"
-    option :bind, type: :string, desc: "override web.bind"
-    option :port, type: :numeric, desc: "override web.port"
-    def web
-      if options[:json]
+    desc "web SUBCOMMAND", "Run the hivebox web UI, or manage its service lifecycle"
+    long_desc <<~DESC
+      Subcommands:
+        run                         Run the web server in the foreground (default).
+                                    Execs bin/rails server; binds web.bind:web.port
+                                    (default 127.0.0.1:4567). Local loopback bind
+                                    requires no auth (single-user local mode);
+                                    binding a non-loopback interface without
+                                    web.github.owner or --allow-non-loopback is refused.
+        install [--force] [--json]  (Re)write the platform-native unit
+                                    (systemd-user / launchd) and enable autostart.
+                                    The web service is SEPARATE from hive-daemon.
+                                    --json emits hive-web-install.v1.
+        start [--json]              Start the managed web service via the service manager.
+                                    --json emits hive-web-start.v1.
+        stop [--json]               Stop the managed web service via the service manager.
+                                    --json emits hive-web-stop.v1.
+        status [--json]             Show the managed web service state. --json emits
+                                    hive-web-status.v1.
+
+      The web UI is a Rails app in web/ shipped in the hivebox Docker image;
+      local mode runs it from a source checkout or a HIVEBOX_WEB_APP_DIR.
+    DESC
+    option :bind, type: :string, desc: "override web.bind (run only)"
+    option :port, type: :numeric, desc: "override web.port (run only)"
+    option :force, type: :boolean, default: false,
+                   desc: "for install: overwrite an existing unit (saves <path>.bak)"
+    option :allow_non_loopback, type: :boolean, default: false,
+                                desc: "for run: allow a non-loopback bind without web.github.owner (loud warning)"
+    def web(subcommand = nil)
+      require "hive/commands/web"
+      subcommand = (subcommand || "run").to_s
+
+      # Foreground `run` is long-lived and has no JSON. The lifecycle
+      # subcommands (install/status/stop) ARE JSON-capable and accept
+      # --json normally. Mirror `hive tui`'s rejection for run only.
+      if subcommand == "run" && options[:json]
         require "json"
-        message = "hive web has no JSON output (it runs a long-lived server). " \
+        message = "hive web run has no JSON output (it runs a long-lived server). " \
                   "Use 'hive status --json' for machine-readable task data."
-        # Mirror `hive tui`'s rejection: emit a structured error envelope (sans
-        # `schema`, since web has no registered hive-* schema) and raise
-        # InvalidTaskPath for the USAGE (64) exit code — parity with every
-        # other --json failure on this surface.
         puts JSON.generate(
           "ok" => false,
           "error_class" => "InvalidTaskPath",
@@ -1354,8 +1430,14 @@ module Hive
         raise Hive::InvalidTaskPath, message
       end
 
-      require "hive/commands/web"
-      Hive::Commands::Web.new(bind: options[:bind], port: options[:port]).call
+      Hive::Commands::Web.new(
+        subcommand,
+        bind: options[:bind],
+        port: options[:port],
+        json: options[:json],
+        force: options[:force],
+        allow_non_loopback: options[:allow_non_loopback]
+      ).call
     end
 
     desc "tui", "Open the live, keystroke-driven dashboard for every active task"
diff --git a/lib/hive/commands/daemon.rb b/lib/hive/commands/daemon.rb
index 6c91610b1..e71f71543 100644
--- a/lib/hive/commands/daemon.rb
+++ b/lib/hive/commands/daemon.rb
@@ -19,6 +19,7 @@ require "hive/daemon/logger"
 require "hive/daemon/dispatch_request_queue"
 require "hive/invoked_binary"
 require "hive/update_check/state"
+require "hive/daemon/drift"
 
 module Hive
   module Commands
@@ -37,7 +38,7 @@ module Hive
       include Hive::Schemas::EnvelopeEmitter
       include Hive::PidFile
 
-      VALID_SUBCOMMANDS = %w[start stop status reload tail enable disable install queue].freeze
+      VALID_SUBCOMMANDS = %w[start stop status reload tail enable disable install queue repair].freeze
 
       # Actions for `hive daemon queue ACTION` (AN-1/2/3). `list` is the
       # default when no action is given.
@@ -86,6 +87,7 @@ module Hive
         when "reload"           then reload_daemon
         when "tail"             then tail_daemon
         when "install"          then install_daemon
+        when "repair"           then repair_daemon
         when "queue"            then queue_command
         when "enable", "disable" then call_with_envelope { do_call }
         end
@@ -371,6 +373,7 @@ module Hive
 
         if @json
           service_state = probe_service_state
+          drift = running ? drift_payload(pid) : nil
           puts JSON.generate(
             "schema" => "hive-daemon-status",
             "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-daemon-status"),
@@ -386,7 +389,14 @@ module Hive
             # Agent-native parity with the TUI footer / bot push: expose the
             # update nudge so a programmatic caller can detect "behind" too.
             "current_version" => Hive::VERSION,
-            "update_nudge" => update_nudge_payload
+            "update_nudge" => update_nudge_payload,
+            # U5 binary/version consistency: report the RUNNING daemon's
+            # binary + version vs the CLI, plus drift. Null when not running;
+            # status "unverified" when the live binary can't be resolved.
+            "daemon_binary" => drift && drift["binary"],
+            "daemon_version" => drift && drift["version"],
+            "drift_status" => drift && drift["status"],
+            "drifted" => drift && drift["drifted"]
           )
         elsif running
           puts "hive daemon: running (pid #{pid}, uptime #{uptime_sec}s)"
@@ -420,6 +430,54 @@ module Hive
         nil
       end
 
+      # U5: resolve the RUNNING daemon's binary/version vs the CLI. Never
+      # raises out of status; any failure degrades to the unverified shape.
+      def drift_payload(pid)
+        @drift_payload ||= Hive::Daemon::Drift.new(pid: pid).resolve
+      rescue StandardError
+        { "binary" => nil, "version" => nil, "status" => "unverified", "drifted" => nil }
+      end
+
+      # `hive daemon repair` — explicit binary/version-drift repair. When the
+      # running daemon's binary/version differs from the CLI (or it can't be
+      # verified), re-run `install --force` with autostart, which rewrites
+      # the unit to point at the CLI's binary and restarts the running
+      # service. Drift is deliberately NOT silently auto-fixed elsewhere;
+      # this is the explicit path invoked by `hive setup` and the web repair
+      # button.
+      def repair_daemon
+        require "hive/commands/daemon/service_installer"
+        # Re-write the unit pointing at the CURRENT CLI binary and restart.
+        # `autostart: true` (mirroring `hive daemon install`) makes the
+        # installer restart the running service on the force-upgrade path, so
+        # a drifted daemon actually starts running the matching binary instead
+        # of keeping the stale one alive.
+        installer = Hive::Commands::Daemon::ServiceInstaller.new(binary_path: current_binary_path)
+        outcome = installer.install!(autostart: true, force: true)
+        unless outcome.success?
+          message = "hive daemon: repair failed — reinstall reported #{outcome.wire_outcome}"
+          raise Hive::DaemonInstallFailed, message
+        end
+        if @json
+          puts JSON.generate(
+            "schema" => "hive-daemon-repair",
+            "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-daemon-repair"),
+            "ok" => true,
+            "outcome" => outcome.wire_outcome,
+            "target_path" => installer.target_path,
+            "restarted" => outcome.restarted
+          )
+        else
+          installer.messages.each { |line| warn "hive: #{line}" }
+          puts "hive daemon: repair requested — unit rewritten at #{installer.target_path}; " \
+               "daemon restart triggered"
+        end
+      rescue Hive::DaemonInstallFailed
+        raise
+      rescue StandardError => e
+        raise Hive::DaemonInstallFailed, "hive daemon: repair failed: #{e.class}: #{e.message}"
+      end
+
       def reload_daemon
         result = compute_reload_outcome
         if @json
diff --git a/lib/hive/commands/doctor.rb b/lib/hive/commands/doctor.rb
index 99afbc08b..c23401df3 100644
--- a/lib/hive/commands/doctor.rb
+++ b/lib/hive/commands/doctor.rb
@@ -33,9 +33,9 @@ module Hive
     # (the daemon, an outer orchestrator) can decide how to react
     # without scraping the human-readable table.
     class Doctor
-      EXIT_SUCCESS = 0
-      EXIT_MISSING_SKILL = 65
-      EXIT_CONFIG_ERROR = 78
+      EXIT_SUCCESS = Hive::ExitCodes::SUCCESS
+      EXIT_MISSING_SKILL = Hive::ExitCodes::FIX_REQUIRED
+      EXIT_CONFIG_ERROR = Hive::ExitCodes::CONFIG
 
       STAGES = %w[brainstorm plan].freeze
 
